// (c) Copyright 2013 Cloudera, Inc. All rights reserved.
//
// Manages querying and showing SysSQL results.
//
// Missing functionality/TODOs:
// - URL addressability
// - Visualizations
// - Exposure of timeout values
// - Column listings for tables
// - Saving/recent queries

define(["cloudera/Util","cloudera/common/I18n","cloudera/common/I18nDataTable","cloudera/common/Humanize","cloudera/cmf/include/DataTableUtil","underscore","cloudera/cmf/include/DataTableColumnRenderer","knockout"],function(e,t,n,r,i,s,o,u){return function(e){var t=this;t.errors=u.observableArray(),t.logs=u.observableArray(),t.counters=u.observableArray(),t.stats=u.observable({}),t.query=u.observable(""),t.busy=u.observable(!1),t.data={},t.schemas=u.observableArray(),t.examples=u.observableArray(),t.availableSourceTimeouts=u.observableArray(["1","4","10","60","120","600"]),t.availableQueryTimeouts=u.observableArray(["10","60","120","600"]),t.sourceTimeout=u.observable("10"),t.queryTimeout=u.observable("10"),t.showingCounters=u.observable(!1),t.showingLogs=u.observable(!1),t.$dt=$(e.resultsSelector),t.$resultsAnchor=$(e.resultsAnchorSelector),t.$body=$(e.bodySelector),t.$schema=$(e.schemaSelector),t.$example=$(e.exampleSelector),t.$page=$(e.pageSelector),t.$help_popover=$(e.helpPopoverSelector),t.$help_tooltip=$(e.helpTooltipSelector),t.toggleCounters=function(){t.showingCounters(!t.showingCounters())},t.toggleLogs=function(){t.showingLogs(!t.showingLogs())},t.handleResult=function(e){t.dataTable&&(t.dataTable.fnDestroy(),t.dataTable=undefined,t.$dt.empty(),t.stats({}));if(e.errors.length===0){var n=0,r={aaData:e.data,aoColumnDefs:s.map(e.columns,function(e){return{sTitle:e,aTargets:[n++]}}),iDisplayLength:100,bDestroy:!0,aaSorting:[]};i.initialize("results",r,!0,{settingsKey:"sysSQL"}),t.dataTable=t.$dt.dataTable(),t.data=e}t.errors.removeAll(),t.logs.removeAll(),t.counters.removeAll(),t.errors(e.errors),s.each(e.counters,function(e,n){t.counters.push({value:e,key:n})}),t.logs(e.logs),t.stats(t.statsFromResult(e)),t.$body.animate({scrollTop:t.$resultsAnchor.offset().top-40})},t.statsFromResult=function(e){var t={};return t.bytes=r.humanizeBytes(e.counters.bytes),t.rows=e.data.length,t.cpu=e.counters.cpu,t.execute_query=e.counters.execute_query,t.remotes_success=e.counters.remotes_success,t.remotes_total=e.counters.remotes_total,t},t.runQuery=function(){t.busy(!0),$.ajax({url:"/cmf/syssql/query",dataType:"json",data:{query:t.query(),sourceTimeout:t.sourceTimeout(),queryTimeout:t.queryTimeout()}}).done(function(e){t.handleResult(e)}).fail(function(e,n,r){t.logs.removeAll(),t.counters.removeAll(),t.stats({}),t.errors([n+": "+e.statusText+":"+r])}).always(function(){t.busy(!1)})},t.doSelectTable=function(e){t.query("SELECT * FROM "+e.name),t.runQuery()},t.doExampleQuery=function(e){t.query(e.query),t.runQuery()},$.getJSON("/cmf/syssql/schemas",function(e){t.schemas(e),t.$schema.tooltip({placement:"bottom"})}),$.getJSON("/cmf/syssql/examples",function(e){t.examples(e),t.$example.tooltip({placement:"bottom",title:""})}),t.$help_popover.popover({placement:"bottom",trigger:"hover",delay:{show:0,hide:1e3}}),t.$help_tooltip.tooltip({placement:"bottom",title:""}),u.applyBindings(t,t.$page[0])}})